From 944521ad0f062aefeb8e9445c7b0c2089d99a4a9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 26 2021 21:58:38 +0000
Subject: [PATCH 2206/2232] Add some more mut return ui tests


---

diff --git a/tests/ui/mut_return.rs b/tests/ui/mut_return.rs
index 74a5c69..aef3680 100644
--- a/tests/ui/mut_return.rs
+++ b/tests/ui/mut_return.rs
@@ -1,10 +1,16 @@
 #[cxx::bridge]
 mod ffi {
+    extern "Rust" {
+        type Mut<'a>;
+    }
+
     unsafe extern "C++" {
         type Thing;
 
         fn f(t: &Thing) -> Pin<&mut CxxString>;
         unsafe fn g(t: &Thing) -> Pin<&mut CxxString>;
+        fn h(t: Box<Mut>) -> Pin<&mut CxxString>;
+        fn i<'a>(t: Box<Mut<'a>>) -> Pin<&'a mut CxxString>;
     }
 }
 
diff --git a/tests/ui/mut_return.stderr b/tests/ui/mut_return.stderr
index d6ddb88..76ac7db 100644
--- a/tests/ui/mut_return.stderr
+++ b/tests/ui/mut_return.stderr
@@ -1,5 +1,17 @@
 error: &mut return type is not allowed unless there is a &mut argument
- --> $DIR/mut_return.rs:6:9
-  |
-6 |         fn f(t: &Thing) -> Pin<&mut CxxString>;
-  |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+  --> $DIR/mut_return.rs:10:9
+   |
+10 |         fn f(t: &Thing) -> Pin<&mut CxxString>;
+   |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+error: &mut return type is not allowed unless there is a &mut argument
+  --> $DIR/mut_return.rs:12:9
+   |
+12 |         fn h(t: Box<Mut>) -> Pin<&mut CxxString>;
+   |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+
+error: &mut return type is not allowed unless there is a &mut argument
+  --> $DIR/mut_return.rs:13:9
+   |
+13 |         fn i<'a>(t: Box<Mut<'a>>) -> Pin<&'a mut CxxString>;
+   |         ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

